<template>
  <v-app dark>
    <v-navigation-drawer v-model="drawer" temporary absolute hide-overlay>
      <v-list-item>
        <v-list-item-content>
          <v-list-item-title class="title">
            Ikesugi Web
          </v-list-item-title>
          <v-list-item-subtitle>
            Menu
          </v-list-item-subtitle>
        </v-list-item-content>
      </v-list-item>

      <v-divider></v-divider>

      <v-list>
        <v-list-item
          v-for="(item, i) in items"
          :key="i"
          :to="item.to"
          router
          exact
        >
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title v-text="item.title" />
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>
    <v-app-bar app>
      <v-app-bar-nav-icon @click.stop="drawer = !drawer" />
      <v-toolbar-title v-text="title" />
      <v-spacer />
      <template v-if="!$vuetify.breakpoint.mobile">
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              icon
              v-bind="attrs"
              @click.stop="isOpenProfile = !isOpenProfile"
              v-on="on"
            >
              <v-icon>mdi-account-details-outline</v-icon>
            </v-btn>
          </template>
          <span>Profile</span>
        </v-tooltip>
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn icon v-bind="attrs" v-on="on" @click="onCopy(email)">
              <v-icon>mdi-email</v-icon>
            </v-btn>
          </template>
          <span>E-mail</span>
        </v-tooltip>
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              v-bind="attrs"
              icon
              href="https://gitlab.com/ikesugi-web"
              target="_blank"
              rel="noopener noreferrer"
              v-on="on"
            >
              <v-icon>mdi-gitlab</v-icon>
            </v-btn>
          </template>
          <span>GitLab</span>
        </v-tooltip>
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              v-bind="attrs"
              icon
              href="https://github.com/namasugi"
              target="_blank"
              rel="noopener noreferrer"
              v-on="on"
            >
              <v-icon>mdi-github</v-icon>
            </v-btn>
          </template>
          <span>Github</span>
        </v-tooltip>
      </template>
    </v-app-bar>
    <v-content class="gray lighten-3">
      <v-container>
        <nuxt />
      </v-container>
    </v-content>
    <notification
      v-model="profile.isOpenInfo"
      :type="profile.type"
      :text="profile.text"
    />
    <v-bottom-navigation
      v-if="$vuetify.breakpoint.mobile"
      color="indigo lighten-1"
      app
    >
      <v-btn icon @click.stop="isOpenProfile = !isOpenProfile">
        <v-icon>mdi-account-details-outline</v-icon>
      </v-btn>
      <v-btn icon v-bind="attrs" v-on="on" @click="onCopy(email)">
        <v-icon>mdi-email</v-icon>
      </v-btn>
      <v-btn
        v-bind="attrs"
        icon
        href="https://gitlab.com/ikesugi-web"
        target="_blank"
        rel="noopener noreferrer"
        v-on="on"
      >
        <v-icon>mdi-gitlab</v-icon>
      </v-btn>
      <v-btn
        v-bind="attrs"
        icon
        href="https://github.com/namasugi"
        target="_blank"
        rel="noopener noreferrer"
        v-on="on"
      >
        <v-icon>mdi-github</v-icon>
      </v-btn>
    </v-bottom-navigation>
    <v-dialog
      v-model="isOpenProfile"
      max-width="400"
      :fullscreen="$vuetify.breakpoint.xsOnly"
    >
      <v-card>
        <v-card-actions class="mb-4">
          <div class="pl-4 pt-4 display-1 text--primary">
            Profile
          </div>
          <v-spacer />
          <v-btn icon @click="isOpenProfile = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-actions>

        <v-card-text>
          <div class="text--primary">いけすぎウェブ</div>
          <p>フリーでWebシステムのエンジニアをやっています。</p>
          <div>
            <div class="caption">会社員時代</div>
            <div class="text--primary">
              いわゆるプレイングマネージャーで下流から上流まで全工程の経験を積む。
            </div>
            <p class="text--primary">
              1人から10名規模のプロジェクトでフルスクラッチ、カスタマイズ開発どちらも実績あり。
            </p>
          </div>
          <div>
            <div class="caption">得意なスキルセット</div>
            <p class="text--primary">JavaScript, PHP, Java, MySQL</p>
          </div>
          <div>
            <div class="caption">最近</div>
            <p class="text--primary">Vue.js->Laravel構成が多い</p>
          </div>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-footer absolute app>
      <span class="d-flex justify-center"
        >&copy; {{ new Date().getFullYear() }} ikesugi web</span
      >
    </v-footer>
  </v-app>
</template>

<script>
import Notification from '@/components/Notification'
export default {
  components: {
    Notification,
  },
  data() {
    return {
      drawer: false,
      items: [
        {
          icon: 'mdi-apps',
          title: 'Top',
          to: '/',
        },
        {
          icon: 'mdi-information-outline',
          title: 'About',
          to: '/about',
        },
        {
          icon: 'mdi-bulletin-board',
          title: 'Todo',
          to: '/todo',
        },
      ],
      title: 'いけすぎウェブ',
      isOpenProfile: false,
      profile: {
        isOpenInfo: false,
        type: '',
        text: '',
      },
      email: 'info@ikesuig-web.com',
    }
  },
  methods: {
    onCopy(value) {
      this.$copyText(value)
        .then(() => {
          this.profile.type = 'info'
          this.profile.text = 'クリップボードにコピーしました。'
          this.profile.isOpenInfo = true
        })
        .catch((e) => {
          this.profile.type = 'info'
          this.profile.text = 'コピーに失敗しました。'
          this.profile.isOpenInfo = true
        })
    },
  },
}
</script>
